Index: /branches/LMDZ_WRFmeas/WRFV3/Registry/Registry.EM.WRFmeas.v3.6.1
===================================================================
--- /branches/LMDZ_WRFmeas/WRFV3/Registry/Registry.EM.WRFmeas.v3.6.1	(revision 592)
+++ /branches/LMDZ_WRFmeas/WRFV3/Registry/Registry.EM.WRFmeas.v3.6.1	(revision 592)
@@ -0,0 +1,79 @@
+#  Registry file, EM
+
+#INCLUDES
+include registry.dimspec
+include Registry.EM_COMMON
+include registry.io_boilerplate
+
+include registry.fire
+include registry.avgflx
+include registry.stoch
+include registry.les
+include registry.cam
+include registry.clm
+include registry.ssib
+include registry.lake
+include registry.diags
+include registry.afwa
+include registry.sbm
+include registry.bdy_perturb
+
+# added to output 5 for ESMF
+state   real   landmask            ij    misc          1     -     i0125rh05d=(interp_fcnm_imask)u=(copy_fcnm)   "LANDMASK"      "LAND MASK (1 FOR LAND, 0 FOR WATER)"  ""
+state   real   lakemask            ij    misc          1     -     i012rhd=(interp_fcnm_imask)u=(copy_fcnm)      "LAKEMASK"      "LAKE MASK (1 FOR LAKE, 0 FOR NON-LAKE)"  ""
+
+# Masked SST interpolation from the CG
+#state    real   SST              ij    misc        1         -     i01245rh05d=(interp_mask_field:lu_index,iswater)f=(p2c_mask:lu_index,tslb,num_soil_layers,iswater)   "SST"              "SEA SURFACE TEMPERATURE" "K"
+# Simple SST interpolation from the CG
+#state    real   SST              ij    misc        1         -     i01245rh05d=(interp_mask_field:lu_index,iswater)f=(p2c)   "SST"              "SEA SURFACE TEMPERATURE" "K"
+state    real   SST              ij     misc        1         -     i01245rh05d=(interp_mask_field:lu_index,iswater)   "SST"              "SEA SURFACE TEMPERATURE" "K"
+state    real   SST_INPUT        ij     misc        1         -     rh   "SST_INPUT"              "SEA SURFACE TEMPERATURE FROM WRFLOWINPUT FILE" "K"
+
+
+# Registry entries that are exclusive to Registry.EM
+
+# Chem Scalars
+rconfig   integer     chem_opt            namelist,physics	max_domains    0       rh       "chem_opt"              ""      ""
+state   real    -              ikjftb   chem        1         -     -    -                                       
+#
+# Tracer Scalars: If you want full resolved and non-resolved dispersion, compile WRF-Chem
+#
+state   real    -          ikjftb  tracer        1         -     -    -                                       
+state   real    tr17_1     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_1"         "tr17_1"          -
+state   real    tr17_2     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_2"         "tr17_2"          -
+state   real    tr17_3     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_3"         "tr17_3"          -
+state   real    tr17_4     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_4"         "tr17_4"          -
+state   real    tr17_5     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_5"         "tr17_5"          -
+state   real    tr17_6     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_6"         "tr17_6"          -
+state   real    tr17_7     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_7"         "tr17_7"          -
+state   real    tr17_8     ikjftb  tracer        1         -     irhusdf=(bdy_interp:dt)    "tr17_8"         "tr17_8"
+
+package   tracer_test1  tracer_opt==2       -             tracer:tr17_1,tr17_2,tr17_3,tr17_4,tr17_5,tr17_6,tr17_7,tr17_8
+
+# Lidar variables
+state    real   lidar_hour      {bflid}{nlid} misc      -         -      -        "LIDAR_HOUR"     "Model integration time, hours"
+state    real   lidar_z         {bflid}k{nlid} misc     -         -      -        "LIDAR_Z"        "Height (geopt/g)"
+state    real   lidar_p         {bflid}k{nlid} misc     -         -      -        "LIDAR_P"        "pressure"
+state    real   lidar_u         {bflid}k{nlid} misc     -         -      -        "LIDAR_U"        "wind U-component, earth-relative"
+state    real   lidar_v         {bflid}k{nlid} misc     -         -      -        "LIDAR_V"        "wind V-component, earth-relative"
+state    real   lidar_w         {bflid}k{nlid} misc     -         -      -        "LIDAR_W"        "wind Z-component, earth-relative"
+state    real   lidar_t         {bflid}k{nlid} misc     -         -      -        "LIDAR_T"        "Potenatial temperature"
+state    real   lidar_qv        {bflid}k{nlid} misc     -         -      -        "LIDAR_QV"       "Water Vapor mixing ratio"
+state    real   lidar_qc        {bflid}k{nlid} misc     -         -      -        "LIDAR_QC"       "Cloud mixing ratio"
+state    real   lidar_qr        {bflid}k{nlid} misc     -         -      -        "LIDAR_QR"       "Rain Vapor mixing ratio"
+state    real   lidar_qs        {bflid}k{nlid} misc     -         -      -        "LIDAR_QS"       "Snow Vapor mixing ratio"
+state    real   lidar_qh        {bflid}k{nlid} misc     -         -      -        "LIDAR_QH"       "Hail Vapor mixing ratio"
+state    real   lidar_qi        {bflid}k{nlid} misc     -         -      -        "LIDAR_QI"       "Ice Vapor mixing ratio"
+state    real   lidar_qg        {bflid}k{nlid} misc     -         -      -        "LIDAR_QG"       "Graupel Vapor mixing ratio"
+state    real   lidar_dens      {bflid}k{nlid} misc     -         -      -        "LIDAR_DENS"     "Density"
+state    real   lidar_cldfra    {bflid}k{nlid} misc     -         -      -        "LIDAR_CLDFRA"   "cloud fraction"
+state    real   lidar_drydens   {bflid}{nlid} misc      -         -      -        "LIDAR_DRYDENS"  "total pressure dry air column"
+state    real   lidar_psfc      {bflid}{nlid} misc      -         -      -        "LIDAR_PSFC"     "Surface pressure"
+state    real   lidar_rainc     {bflid}{nlid} misc      -         -      -        "LIDAR_RAINC"    "Cumulus precip"
+state    real   lidar_rainnc    {bflid}{nlid} misc      -         -      -        "LIDAR_RAINNC"   "Grid-scale precip"
+
+## Namelist parameters
+rconfig   integer   lidar_buf_size  namelist,domains    1                200          -       "lidar_buf_size"   "Size of lidar buffer"
+rconfig   integer   max_lidar_locs  namelist,domains    1                5            -       "max_lidar_locs"   "Maximum number of lidar locations"
+
+ 